<?php
/**
	@file excepcion.php
	Fichero con la clase Excepcion.
	@copy Copyright Ilke Benson 2008
	@author Miguel Jaque Barbero (mjaque@ilkebenson.com)
	@version 1.0
	@date 2008-01-22

**/
class Excepcion extends Exception{

	const MENSAJE_DEFECTO = "Reintente la operación y, si el problema persiste, póngase en contacto con el administrador.";

	//Atributos
	public $titulo;
	public $texto;
	public $solucionProgramador;
	public $solucionUsuario;

	public function __construct($titulo,$texto='',$solucionProgramador='',$solucionUsuario){
		$this->titulo = $titulo;
		$this->texto = $texto;
		$this->solucionProgramador = $solucionProgramador;
		if (!isset($solucionUsuario))
			$solucionUsuario = self::MENSAJE_DEFECTO;
		$this->solucionUsuario = $solucionUsuario;
		parent::__construct($this->__toString());
	}
	public function __toString(){
		$texto = get_class($this)." - ".$this->titulo;
		$texto .= "\n".$this->texto;
		$texto .= "\n".$this->solucionProgramador;
		$texto .= "\n".$this->solucionUsuario;
		return $texto;
	}
}

return true;	//Indicador de carga para __autoload
?>
